/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * Gutu Marius-Gabriel, 331CA
 * Slots
 *********************************************************************************/
 
#include <avr\io.h>
#include <avr\interrupt.h>
#define F_CPU 1000000UL  // 1 MHz
#include <util\delay.h>
#include <stdio.h>
#include <stdlib.h>

// butonul
#define BUTON	PD6
// port buton
#define PORT_BUTON	PORTD

// anoduri 7-led display
// 12 la 22
#define ANOD1	PC0
// 9 la 23
#define ANOD2	PC1
// 8 la 24
#define ANOD3	PC2

// catoduri 7-led display
// 1 la 40
#define CATOD1	PA0
// 2 la 39
#define CATOD2 	PA1
// 4 la 38
#define CATOD3 	PA2
// 5 la 37
#define CATOD4 	PA3
// 7 la 36
#define CATOD5 	PA4
// 10 la 35
#define CATOD6 	PA5
// 11 la 34
#define CATOD7 	PA6

// port anoduri
#define ANOD_PORT	PORTC
// port catoduri
#define CATOD_PORT	PORTA

int main()
{

	// cele 3 cifre
	int a, b, c;

	// generam numerele la inceput
	a = rand()%10;
	b = rand()%10;
	c = rand()%10;

	do 
	{		
		
		// afisare cifra a
		ANOD_PORT |=  (1<<ANOD1);
		// in functie de rezultat, activam catodurile
		switch(a)
		{
			case 0:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 1:
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD5);
				break;
			case 2:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 3:
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 4:
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				break;
			case 5:
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 6:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 7:
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 8:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 9:
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
		}
		// asteptam o milisecunda
		_delay_ms(1);
		// dezactivam cifra a
		ANOD_PORT &=  ~(1<<ANOD1);
		
		// dezactivam catodurile
		CATOD_PORT &=  ~(1<<CATOD1);
		CATOD_PORT &=  ~(1<<CATOD2);
		CATOD_PORT &=  ~(1<<CATOD3);
		CATOD_PORT &=  ~(1<<CATOD4);
		CATOD_PORT &=  ~(1<<CATOD5);
		CATOD_PORT &=  ~(1<<CATOD6);
		CATOD_PORT &=  ~(1<<CATOD7);
		// sfarsit afisare cifra a
		
		// afisare cifra b
		ANOD_PORT |=  (1<<ANOD2);
		// in functie de rezultat, activam catodurile
		switch(b)
		{
			case 0:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 1:
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD5);
				break;
			case 2:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 3:
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 4:
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				break;
			case 5:
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 6:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 7:
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 8:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 9:
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
		}
		// asteptam o milisecunda		
		_delay_ms(1);
		// dezactivam cifra b
		ANOD_PORT &=  ~(1<<ANOD2);
		
		// dezactivam catodurile
		CATOD_PORT &=  ~(1<<CATOD1);
		CATOD_PORT &=  ~(1<<CATOD2);
		CATOD_PORT &=  ~(1<<CATOD3);
		CATOD_PORT &=  ~(1<<CATOD4);
		CATOD_PORT &=  ~(1<<CATOD5);
		CATOD_PORT &=  ~(1<<CATOD6);
		CATOD_PORT &=  ~(1<<CATOD7);
		// sfarsit afisare cifra b
		
		// afisare cifra c
		ANOD_PORT |=  (1<<ANOD3);
		// in functie de rezultat, activam catodurile
		switch(c)
		{
			case 0:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 1:
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD5);
				break;
			case 2:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 3:
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 4:
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				break;
			case 5:
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 6:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 7:
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 8:
				CATOD_PORT |=  (1<<CATOD1);
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
			case 9:
				CATOD_PORT |=  (1<<CATOD2);
				CATOD_PORT |=  (1<<CATOD3);
				CATOD_PORT |=  (1<<CATOD4);
				CATOD_PORT |=  (1<<CATOD5);
				CATOD_PORT |=  (1<<CATOD6);
				CATOD_PORT |=  (1<<CATOD7);
				break;
		}
		// asteptam o milisecunda
		_delay_ms(1);
		// dezactivam cifra c
		ANOD_PORT &=  ~(1<<ANOD3);
		
		// dezactivam catodurile
		CATOD_PORT &=  ~(1<<CATOD1);
		CATOD_PORT &=  ~(1<<CATOD2);
		CATOD_PORT &=  ~(1<<CATOD3);
		CATOD_PORT &=  ~(1<<CATOD4);
		CATOD_PORT &=  ~(1<<CATOD5);
		CATOD_PORT &=  ~(1<<CATOD6);
		CATOD_PORT &=  ~(1<<CATOD7);
		// sfarsit afisare cifra c
		
		// daca cifrele sunt egale, asteptam 0.2 secunde pentru a face efectul de castig
		// (ledurile se sting si se aprind in continuu)
		if (a == b && b == c) _delay_ms(200);
	
		// daca butonul este apasat
		if (1<<BUTON)
		{
			// regeneram numerele
			a = rand()%10;
			b = rand()%10;
			c = rand()%10;
		}
		
	} while(1);
	
	
	return 0;
}
